<?

function mydb_ora_connect($database, $server = "localhost",$login,$pw = "") {
 $db = @ociplogon($login,$pw,$database);
 if (!$db) { 
 $error = ocierror();
 halt(1,"<b>ERROR:</b> Could not connect to database $database, errorcode: ".$error["code"] .", message: ".$error["message"]);
 } else {








 return $db;
 }
}

function mydb_ora_close($db) {
 return @ocilogoff($db);
}

function mydb_ora_exec($sql,$db = 0, $halt = true) {
 global $DB,$HALT;
 if ($db) $mydb = $db;
 else $mydb = $DB;

 if (is_array($mydb)) {
 $handle = $mydb;
 $mydb = $mydb["handle"];
 }
 
 $rs = @ociparse($mydb,$sql);

 if (!$rs) {
 $error = ocierror($mydb);
 if (!$HALT) halt(2, "<b>SQL:</b>".$sql."<br><b>ERROR:</b> ".$error["code"].": ".$error["message"]);
 else return false;
 }
 $err = @ociexecute($rs, $handle["autocommit"]?OCI_COMMIT_ON_SUCCESS:OCI_DEFAULT);
 if (!$err) {
 $error = ocierror($rs);
 if (!$HALT) halt(2, "<b>SQL:</b>".$sql."<br><b>ERROR:</b> ".$error["code"].": ".$error["message"]);
 else return false;
 }

 return $rs;
}

function mydb_ora_fetch($rs,$way = OCI_ASSOC) {
 $row = array();

 OCIFetchinto($rs,&$row,OCI_ASSOC + OCI_RETURN_NULLS); 

 $r = array();

 reset($row);
 while (list($key,$val) = each($row)) {
 $r[strtolower($key)] = $val;
 }

 return $r;
}

function mydb_ora_query($sql, $cache = false, $limit = 0, $db = 0, $way = MYSQL_BOTH, $bind = false, $bindtype = 1) {

 if ($cache && strtolower($sql[0]) == "s") return cache($sql,"ora", $limit, $db, $way);

 global $DB, $DEBUG, $HALT, $QUERY_EFFORT, $QUERY_SPEED, $CACHE_SQL, $DEBUG, $USER_ID, $TIME, $TABLE_LOCK;
 if (!$USER_ID) $USER_ID = 0;

 if ($DEBUG["log_query"] && (strtolower($sql[0]) == "d" || strtolower($sql[0].$sql[1]) == "up") && !$TABLE_LOCK) {
 $_sql = "INSERT INTO logrequest (user_id,request,timestamp) VALUES ($USER_ID,'".sqlslashes($sql)."',$TIME)";
 mydb_ora_query($_sql, false);
 }

 if ($db) $mydb = $db; else $mydb = $DB;

 if (!$mydb) return false;

 if (is_array($mydb)) {
 $handle = $mydb;
 $mydb = $mydb["handle"];
 }
 
 if ($DEBUG["echo"] || $DEBUG["dbtime_fp"]) $t1 = microtime();

 $iid = 0;
 $num = 0;

 $cmd = strtolower(substr($sql,0,6));

 if ($cmd == "insert") {
 if (eregi("^INSERT[ \r\n]+INTO[ \r\n]+([^ ]+)[ \r\n]+\\(([^)]+)\\)[ \r\n]+VALUES[ \r\n]+\\((.+)\\)[ \r\n]*$",$sql,$regs)) {
 $seq = $regs[1];
 $seq_sql = "SELECT $seq"."_seq.nextval FROM dual";
 $seq_st = @ociparse($mydb,$seq_sql);
 if ($seq_st) {
 $err = @ociexecute($seq_st, $handle["autocommit"]?OCI_COMMIT_ON_SUCCESS:OCI_DEFAULT);
 if ($err) {
 @ocifetchinto($seq_st,$row);
 $iid = $row[0];
 if ($iid) 
 $sql = "INSERT INTO $seq (id,$regs[2]) VALUES ($iid,$regs[3])";
 }
 }
 }
 }
 
 if (is_array($bindtype)) {
 $field = $bindtype["field"];
 $bindtype = $bindtype["type"];
 }
 if ($bind != false && !$bindtype) $bindtype = 1;
 if ($bindtype == OCI_B_BLOB) {
 if ($field) {
 $sql = str_replace(":bindvar", "EMPTY_BLOB()", $sql). " RETURNING $field INTO :bindvar";
 } else {
 $lob->WriteTemporary($bind);
 }
 }
 
 if ($bindtype == OCI_B_BLOB) $lob = OCINewDescriptor($mydb, OCI_D_LOB);
 $rs = @ociparse($mydb,$sql);
 
 if ($bind != false) {
 if ($bindtype == OCI_B_BLOB) {
 ocibindbyname($rs,":bindvar",&$lob,-1,$bindtype);
 } else ocibindbyname($rs,":bindvar",$bind,-1,$bindtype);
 }
 if (!$rs) {
 $error = ocierror($mydb);
 if (!$HALT) halt(2, "<b>SQL:</b>".$sql."<br><b>ERROR:</b> ".$error["code"].": ".$error["message"]);
 else return false;
 }
 $err = @ociexecute($rs, $handle["autocommit"]?OCI_COMMIT_ON_SUCCESS:OCI_DEFAULT);
 if (!$err) {
 $error = ocierror($rs);
 if (!$HALT) halt(2, "<b>SQL:</b>".$sql."<br><b>ERROR:</b> ".$error["code"].": ".$error["message"]);
 else return false;
 }

 if ($bind != false && $bindtype == OCI_B_BLOB) {
 if ($field) $lob->save($bind);
 $lob->free();
 }
 
 if ($cmd == "insert") {
 if (!$cache) $CACHE_SQL = Array();
 $DEBUG["insert"]++;
 }

 if ($rs && ($cmd == "select" || substr($cmd,0,4) == "show")) {
 $DEBUG["select"]++;
 $arr = array();
 $num = ocifetchstatement($rs,$arr1);
 if (!$limit) $limit = $num;
 while (list($colname,$onecol) = each($arr1)) {
 while (list($bla,$val) = each($onecol)) {
 if ($bla < $limit)
 $arr[$bla][strtolower($colname)] = $val;
 else break;
 }
 }
 reset($arr);
 }

 if ($cmd == "update") {
 if (!$cache) $CACHE_SQL = Array();
 $DEBUG["update"]++;
 }
 if ($cmd == "delete") {
 if (!$cache) $CACHE_SQL = Array();
 $DEBUG["delete"]++;
 }

 $result["arr"] = $arr;
 $result["num"] = $num;
 $result["iid"] = $iid;

 if ($DEBUG["echo"] || $DEBUG["dbtime_fp"]) {
 $t2 = microtime();
 $tmp = calctime($t1,$t2,5);
 
 $QUERY_EFFORT += $tmp;
 if ($DEBUG["db"]) echo "<br>\n$sql\n<br>$tmp\n<br>";
 }
 return $result;
}

function mydb_ora_create_database($database,$db) {
 return false;
}

?>
