<?php





 
class BackwardCompatibilityDS extends ItemListDataSource
{
 var $itemlist;
 var $sortCol;
 var $sortWay;
 var $enablePaging = FALSE;

 function BackwardCompatibilityDS( &$itemlist, $sortCol, $sortWay )
 {
 $this->itemlist =& $itemlist;
 $this->sortCol = $sortCol;
 $this->sortWay = $sortWay;
 }
 
 function getColumns()
 {
 return $this->itemlist->cols;
 } 
 
 function getColumnHeader( $col )
 {
 return $this->itemlist->head[$col];
 }
 
 function hasColumnHeaders()
 {
 return count( $this->itemlist->head ) > 0 && is_array( $this->itemlist->head );
 }


 function getColumnAttribs( $col )
 {
 return $this->itemlist->addtd[$col];
 }
 
 function isPreSelected( $id ) 
 {
 if ( $this->itemlist->checkall )
 return true;
 return $this->itemlist->checked[$id];
 }
 
 function isAllPreSelected( ) 
 {
 return $this->itemlist->checkall;
 }


 function getResultSet( $from, $to, &$count, $search, $fetchAll = true )
 {
 global $FEATURE;
 $i = 0;

 if ( is_array($this->itemlist->rows) )
 {
 $_ret = array();
 if($FEATURE['itemlist_configurepagesize']) {
 
 $count = count($this->itemlist->rows);
 }
 

 foreach ( $this->itemlist->rows as $_key=>$_row )
 {
 if($FEATURE['itemlist_configurepagesize']) {
 if($i < $from) { $i++; continue; }
 if($to > 0 && $i > $to) break;
 $i++;
 }
 $_retRow = $_row;

 foreach ( $_row as $_col=>$_value )
 {
 $$_col = $_value;
 }

 if ( is_array( $this->itemlist->link ) )
 {
 foreach ( $this->itemlist->link as $_lkey=>$_lnk )
 {
 $_chlnk = $_lnk.$this->itemlist->addval;
 $_e = "\$_elnk=\"$_chlnk\";";
 eval( $_e );

 if ( $this->itemlist->onclick[$_lkey] )
 {
 $_e = "\$_eonclick=\"".$this->itemlist->onclick[$_lkey]."\";";
 eval( $_e );
 $_eonclick = " onclick=\"$_eonclick\" ";
 $__link = $_elnk;
 }
 else
 {
 $_eonclick = "";
 if( $this->itemlist->target[$_lkey] == "_new" ) {
 $__link = $_elnk;
 } else {
 $__link = "javascript:".ProgressStatusInfo::buildProgressLink( $_elnk );
 }
 }

 if ( $this->itemlist->target[$_lkey] )
 $_target = " target =\"".$this->itemlist->target[$_lkey]."\" ";
 else
 $_target = "";
 
 
 $_retRow[$_lkey] = "<a href=\"$__link\" $_eonclick $_target>" . $_retRow[$_lkey] . "</a>";
 }
 }
 if ( is_array( $this->itemlist->pretd ) )
 {
 foreach ( $this->itemlist->pretd as $_ckey=>$_pretd )
 {
 $_e = "\$_epretd=\"$_pretd\";";
 eval( $_e );
 $_retRow[$_ckey] = $_epretd.$_retRow[$_ckey];

 }
 }

 if ( is_array( $this->itemlist->apptd ) )
 {
 foreach ( $this->itemlist->apptd as $_ckey=>$_apptd )
 {
 $_e = "\$_eapptd=\"$_apptd\";";
 eval( $_e );
 $_retRow[$_ckey] = $_retRow[$_ckey].$_eapptd;
 
 }
 }
 $_ret[$_key] = $_retRow;

 
 
 
 extract(array_combine(array_keys($_row), array_fill(0, count($_row), null)));
 }
 if(!$FEATURE['itemlist_configurepagesize']) {
 
 $count = count( $_ret );
 }
 return $_ret;
 }
 else
 {
 $count = 0;
 return null;
 }

 }
 
 function getRowHelp( $rowKey, $rowData )
 {
 if ( $this->itemlist->rowass )
 {
 foreach ( $this->itemlist->rows[$rowKey] as $key=>$value )
 {
 $$key = $value;
 }
 $e = "\$erow_=\"".$this->itemlist->rowass."\";";
 eval( $e );
 return $erow_;
 }
 return null;
 }

 function getRowHelpTitle( $rowKey, $rowData )
 {
 if ( $this->itemlist->rowassTitle )
 {
 foreach ( $this->itemlist->rows[$rowKey] as $key=>$value )
 {
 
 
 if(is_array($value)) $value = $value[0];
 $$key = htmlspecialchars($value);
 }
 $e = "\$erow_=\"".$this->itemlist->rowassTitle."\";";
 eval( $e );
 return $erow_;
 }
 return null;
 }

 function getKey()
 { 
 
 return "ck";
 }

 function setSort( $column, $way )
 {
 }

 function getCurrentSort( &$column, &$way )
 {
 if ( !$this->sortCol )
 return false;

 $column = $this->sortCol;
 $way = $this->sortWay=="ASC"?0:1;;
 return true;
 }

 function getActions() 
 {
 return $this->itemlist->factions;
 }

 


 function setDestructiveActions($actions) {
 $this->itemlist->destructiveActions = $actions;
 }

 



 function isDestructiveAction($action) {
 $destructive = $this->itemlist->destructiveActions[$action];
 return is_null($destructive) || (bool)$destructive;
 }

 function getSingleActions( $rowKey, $rowData )
 {
 return $this->itemlist->singleActions;
 }
 function getActionSortorder() {
 return $this->itemlist->actionSortorder;
 }
 function getAllSingleActions()
 {
 return $this->itemlist->singleActions;
 }

 function getDefaultAction()
 {
 return $this->itemlist->defaultAction;
 }

 function getDefaultJavascriptAction()
 {
 return $this->itemlist->defaultJSAction;
 }
 
 function getActionIcon( $action )
 {
 global $ICO_DELETE;
 if ( is_array($this->itemlist->factionIcons) )
 if ( $this->itemlist->factionIcons[$action] )
 return $this->itemlist->factionIcons[$action];

 if ( $action == "del" )
 return $ICO_DELETE;
 return null;
 }

 function getActionHide( $action )
 {
 if ( is_array($this->itemlist->factionHide) ) {
 if ( $this->itemlist->factionHide[$action] ) {
 return $this->itemlist->factionHide[$action];
 }
 }

 return false;
 }

 function getActionHelp( $action )
 {
 if ( $this->itemlist->factionsass )
 {
 return $this->itemlist->factionsass[$action];
 }
 return null;
 }
 
 function isSearchable()
 {
 return $this->itemlist->isSearchable;
 }
 
 function getSortWays( $column )
 {
 global $STAG_PREFIX;
 if ( !$this->itemlist->isSortable )
 return null;
 
 if ( $this->itemlist->head[$column] && !$this->itemlist->nosort[$column] )
 {
 return array( array( "way"=>"ASC", "icon"=>"$STAG_PREFIX?do=11&module=system&img=sort_asc.gif" ), 
 array( "way"=>"DESC", "icon"=>"$STAG_PREFIX?do=11&module=system&img=sort_desc.gif" ) );
 }
 return null;
 }

 


 function getColumnContextMenu( $column, $row ) {
 if ($this->itemlist->nocontextmenu[$column]) {
 return array();
 } else if (isset($this->itemlist->contextmenu[$column][$row["id"]])) {
 return $this->itemlist->contextmenu[$column][$row["id"]];
 }else if ($this->itemlist->contextmenu[$column]) {
 return $this->itemlist->contextmenu[$column];
 } else {
 return null;
 }
 }
 
 
 function getDefaultItemsPerPageCount() 
 { 
 global $FEATURE, $MAXLISTITEMS, $DEFAULT_MAXLISTITEMS;

 if($FEATURE['itemlist_configurepagesize'] && $this->enablePaging) {
 
 if($MAXLISTITEMS) return $MAXLISTITEMS;
 if($DEFAULT_MAXLISTITEMS) return $DEFAULT_MAXLISTITEMS;
 }

 
 return 939821;
 }

 
}

?>
