<?php




class TodoTool extends NodeObject {
 
 var $baseURL;
 
 


 function onStaticEventNotify( $TType, $id, $changeType, $eventObject, $depth, $simulate ) {
 global $CN_LOCAL_SERVER, $FEATURE, $TODOTOOL_BASEURL;
 if (!$FEATURE["2dotool_integration"]) return;
 if ($eventObject === NULL) return;
 if ($simulate && $simulate > 0) return;
 
 $this->baseURL = "$TODOTOOL_BASEURL/TodoTool/TodoTool/";
 if ($TType === T_PUBQUEUE && $changeType === EVENT_NOTIFY) {
 $this->addPublishTodo($id, $eventObject);
 } else if ($TType === T_PAGE && $changeType === EVENT_DELETE) {
 $this->addBrokenLinkTodo($id, $eventObject);
 } else if ($TType === T_PAGE && $changeType === EVENT_CN_PAGESTATUS && $eventObject->getProperty("brokenlink_notified")) {
 $this->addBrokenLinkTodo($id, $eventObject);
 } else if ($TType === T_USER || $TType === T_GROUP || $TType === T_PAGELANGUAGE) {
 $this->execSync();
 }
 }
 
 


 function execSync() {
 $url = $this->baseURL . '?exec=sync';
 
 $fp = fopen($url, 'r');
 fclose($fp);
 }
 
 


 function addBrokenLinkTodo($pageId, $eventObject) {
 
 $notified = $eventObject->getProperty("notified");
 if(!$notified) $notified = $eventObject->getProperty("brokenlink_notified");
 if (!is_array($notified) || count($notified) == 0) {
 
 return;
 }

 foreach ($notified as $key => $notification) {
 $subject = $notification["subject"];
 $body = get_msg($notification["message_id"], 'text');
 if(!$subject) $subject = body;
 $this->queryTodoTool($notification["editor"], $subject,
 'broken_link', $notification["page_id"], $body);
 }
 }
 
 


 function addPublishTodo($pageId, $eventObject) {
 
 






 
 $userids = $eventObject->getProperty("userids");
 $username = $eventObject->getProperty("username");
 $message_id = $eventObject->getProperty("message_id");
 $subject = $eventObject->getProperty("subject");
 
 if (!is_array($userids) || count($userids) == 0) {
 
 return;
 }
 
 $csuserids = implode( ',', $userids );
 $subject = $subject;
 $text = get_msg( $message_id, 'text' );
 $this->queryTodoTool($csuserids, $subject, 'publish', $pageId, $text);
 }
 
 


 function queryTodoTool($userids, $text, $type, $page_id, $body = NULL) {
 global $STAG_PREFIX, $STAG, $USER_ID, $FOLDER_ID;

 if( $body === NULL ) $body = $text;
 
 $ref = "$STAG&do=14001&PAGE_ID=$page_id&FOLDER_ID=$FOLDER_ID";
 $ref = urlencode(preg_replace("/sid=\w+&/", '', $ref)); 
 $userids = urlencode( $userids );
 
 $text = urlencode($text);
 $body = urlencode($body);
 $url = $this->baseURL . "?systemuserids=$userids&subject=$text&description=$body&type=" . 
 urlencode($type) . "&references=$ref&creator=$USER_ID";
 $fp = fopen($url, 'r');
 
 
 fclose($fp);
 }
}
?>
