<?















function resize_image( &$data, $tmpfile, $resize, $width, $height )
{
 global $CN_IMAGEUPLOAD_SIZE;

 $img = new img_resize($tmpfile);
 $img->clearCache();
 
 switch ($resize) {
 case "icon":
 $img->setProp("maxwidth",22);
 $img->setProp("maxheight",22);
 break;
 case "small":
 $img->setProp("maxwidth",50);
 $img->setProp("maxheight",50);
 $img->setProp("force",true);
 break;
 case "large":
 $img->setProp("maxwidth",400);
 $img->setProp("maxheight",400);
 $img->setProp("force",true);
 break;
 case "percent":
 case "scale":
 if ($width) $img->setProp("width",$width.(($resize=="scale")?"":"%"));
 if ($height) $img->setProp("height",$height.(($resize=="scale")?"":"%"));
 break;
 default:
 if ($size = $CN_IMAGEUPLOAD_SIZE[$resize]) {
 $parts = explode("x",$size);
 if ($parts[0]) $img->setProp("width",(int) $parts[0]);
 if ($parts[1]) $img->setProp("height",(int) $parts[1]);
 }
 }
 $img->setProp("smart",true);

 $img->saveImage($tmpfile."_tmp");
 $img->clearCache();

 $f = fopen($tmpfile."_tmp","rb");
 $size = filesize($tmpfile."_tmp");
 $data = fread($f, $size);
 fclose($f);

 return $size;
 
}



if (empty($_POST) && empty($_FILES) && $form_post) {
 $post_max_size_exceeded = true;
 $cmd = $safe_cmd;
 $type = $safe_type;
 $id = $safe_id;
}

if ( !$TMP_RELOAD )
 GUIFactory::setMainGUI( "main" );
else
 GUIFactory::setMainGUI( "dialog" );

if ($TMP_RELOAD && $reload) {
 mysession_var_reg('TMP_RELOAD');
 mysession_var_reg('TMP_REDO');
} elseif (!$reload && !$f_gentics_submitted) {
 mysession_var_unreg('TMP_RELOAD');
 mysession_var_unreg('TMP_REDO');
 unset($TMP_RELOAD);
 unset($TMP_REDO);
}

if ($id) $FILE_ID = $id;
if ($FEATURE["multichannelling"] && !$f_gentics_submitted && !isEditInheritedVerified($type == "img" || $f_type == "img" ? $T_IMAGE : $T_FILE, $FILE_ID, $NODE_ID) && $cmd != "new") {
 $fileinfo = get_fileinfo($FILE_ID);

 
 $inherited = false;
 $nodeinfo = get_nodeinfo($NODE_ID);

 
 if ($nodeinfo["master_id"] > 0) {
 
 $inherited = $fileinfo["channel_id"] != $NODE_ID;
 }

 if ($inherited) {
 
 $REDO = 13550;
 $OBJ_TYPE = $type == "img" || $f_type == "img" ? $T_IMAGE : $T_FILE;
 $OBJ_ID = $FILE_ID;
 $DO_EDIT = $DO;
 $DO_CANCEL = 15001;
 $OBJ_ID_PARAM = "FILE_ID";
 $DO_PARAMS = array("cmd" => "update", "type" => $type ? $type : $f_type);
 return;
 }
}


if (!$dfolder_id) $dfolder_id = $FOLDER_ID;

$hi = array();

$f = $HI["file"];
$f["label"] = i18n('File');
$f["var"] = "userfile";
$f["help"] = i18n('you_may_choose_a_file_on');
if (($cmd=="new" || $f_cmd == "new") && !$f_filename && !$f_userfile) $f["force"] = true;
$hi[] = $f;

$f = $HI["text"];
$f["label"] = i18n('368.name');
$f["var"] = "name";
$f["help"] = i18n('368.name');
$f["regid"] = REG_FILENAME;


$f["optional"] = ($cmd == "new" || $f_cmd == "new") ? true : false;
$hi[] = $f;

if (($f_cmd == "new" || $cmd == "new") && ($type == "img" || $f_type == "img") && $FEATURE["img_resize"]) {
 $lst = array();
 $lst["orig"] = i18n("cn_original_size");
 $lst["icon"] = i18n("icon"). " (22px)";
 $lst["small"] = i18n("small"). " (50px)";
 $lst["large"] = i18n("large"). " (400px)";
 $lst["percent"] = i18n("cn_image_resize_percent");
 $lst["scale"] = i18n("cn_image_resize_pixel");
 if (is_array($CN_IMAGEUPLOAD_SIZE)) {
 reset($CN_IMAGEUPLOAD_SIZE);
 while (list($key,$val) = each($CN_IMAGEUPLOAD_SIZE)) {
 if (!$lst[$key]) $lst[$key] = "$key ($val)";
 }
 }

 if (!$f_resize) $resize = "orig";

 $f = $HI["sel"];
 $f["label"] = i18n("resize");
 $f["var"] = "resize";
 $f["list"] = $lst;
 $f["nocheck"] = true;
 $f["onchange"] = "&faction=select";
 $f["help"] = i18n("resize_help");
 $hi[] = $f;

 if ($f_resize == "percent" || $f_resize == "scale") {
 $f = $HI["int"];
 $f["label"] = i18n('width') . (($f_resize == "percent")?" (%)":" (px)");
 $f["var"] = "width";
 $f["optional"] = true;
 $f["help"] = i18n("resize_help");
 $hi[] = $f;

 $f = $HI["int"];
 $f["label"] = i18n('height') . (($f_resize == "percent")?" (%)":" (px)");
 $f["var"] = "height";
 $f["optional"] = true;
 $f["help"] = i18n("resize_help");
 $hi[] = $f;
 }
}

$f = $HI["ta"];
$f["label"] = i18n('305.description');
$f["var"] = "description";
$f["help"] = i18n('305.description');
$f["regid"] = 9;
$hi[] = $f;


if ($FILEUPLOAD_MANIPULATOR_URL) {
 






 foreach( $FILEUPLOAD_MANIPULATOR_OPTIONS as $key => $value ) {
 $f = $HI["checkbox"];
 $f["label"] = $value["name"];
 $f["var"] = $key;
 $hi[] = $f;
 }
}




$show_select_folder = false;
if ($reload == 10008 || $f_show_select_folder) {
 $show_select_folder = true;
}

if ($show_select_folder) {

 
 if ($f_p_minifolderf_pfolder_a_x) {
 $mnbr = "folder";
 }

 
 if ($factionapply_x) {
 unset($mnbr);
 unset($f_mnbr);
 }

 $type_mini = array($T_DOMAIN,$T_FOLDER);
 $minitype = "folder";
 $root_mini_type = $T_CONTENT;
 $rs = query("SELECT id FROM tree WHERE type_id = ".sqlf_tl_num($T_CONTENT));
 $root_mini_id = $rs["arr"][0]["id"];

 $f_minitype = "folder";
 $minitype = "folder";

 if ($f_dfolder_id && ($mnbr || $f_mnbr)) {
 $m_folder_id = $f_dfolder_id;
 }

 if ($m_folder_id) {
 $f_m_folder_id = $m_folder_id;
 $f_dfolder_id = $m_folder_id;
 $dfolder_id = $m_folder_id;
 } else {
 if ($f_dfolder_id) {
 $f_m_folder_id = $f_dfolder_id;
 $m_folder_id = $f_dfolder_id; 
 } else {
 $f_m_folder_id = $FOLDER_ID;
 $m_folder_id = $FOLDER_ID;
 $f_dfolder_id = $FOLDER_ID;
 $dfolder_id = $FOLDER_ID;
 
 $node_id = $NODE_ID;
 
 
 
 if (!isset($NODE_ID) && isset($FOLDER_ID)) {
 $folderinfo = get_folderinfo($FOLDER_ID);
 $node_id = $folderinfo["node_id"];
 }
 
 
 $nodeinfo = get_nodeinfo($node_id);

 if ($type == "img" || $f_type == "img") {
 $defaultFolderId = $nodeinfo["default_image_folder_id"];
 } else {
 $defaultFolderId = $nodeinfo["default_file_folder_id"];
 }

 
 if ($defaultFolderId && !perm($USER_ID, $T_FOLDER, $defaultFolderId, 1)) {
 $defaultFolderId = null;
 }

 if ($defaultFolderId) {
 $f_m_folder_id = $defaultFolderId;
 $m_folder_id = $defaultFolderId;
 $f_dfolder_id = $defaultFolderId;
 $dfolder_id = $defaultFolderId;
 }
 }
 }

 
 
 if ($mnbr || $f_mnbr) {
 $myminitree = new minitree($type_mini,$minitype);
 $myminitree->dyn = "m_folder_id";
 $myminitree->build_tree($root_mini_type, $root_mini_id);
 $myminitree->build_list();
 $showminibrowser = true;
 }

 node_class("cnfolderobject");
 $folder = (new CNFolderObject($m_folder_id)); 
 $folder = $folder->getName();
 $f_folder = $folder;

 $f = $HI["hidden"]; 
 $f["var"] = "mnbr";
 $hi[] = $f;
 
 $f = $HI["hidden"]; 
 $f["var"] = "show_select_folder";
 $hi[] = $f;

 if ($mnbr) {
 $f_mnbr = $mnbr;
 }

 $tmp = $HI["dynamic"];
 $tmp["ele"] = "dyna";
 $tmp["label"] = i18n('folder');
 $hi[] = $tmp;

 function dyna() {
 global $HI;
 global $ICO_MINI;

 $hi2 = array();

 $tmp = $HI["disabled"];
 $tmp["var"] = "folder";
 $tmp["label"] = i18n('folder'); 
 $hi2[] = $tmp;

 $tmp = $HI["img"];
 $tmp["var"] = "f_p_minifolder";
 $tmp["value"] = "f_pfolder_a";
 $tmp["src"] = $ICO_MINI;
 $tmp["minibut"] = 1;
 $tmp["onclick"] = "alert('123');";
 $hi2[] = $tmp;

 $f = new htmlform($hi2, "minibrowser");

 return $f->element("folder") . $f->element("f_pfolder_a");
 }

}


$f = $HI["hidden"]; 
$f["var"] = "type";
$hi[] = $f;

$f = $HI["hidden"]; 
$f["var"] = "dfolder_id";
$hi[] = $f;

$f = $HI["hidden"]; 
$f["var"] = "tmp_abort";
$hi[] = $f;
if ($tmp_abort) $f_tmp_abort = $tmp_abort;

$f = $HI["hidden"]; 
$f["var"] = "cmd";
$hi[] = $f;


if ($FEATURE["edit_mimetype"] && $cmd!="new") {
 $f = $HI["text"];
 $f["label"] = "MIME Type";
 $f["var"] = "filetype";
 $f["help"] = "MIME Type";
 $f["optional"] = false;
 $hi[] = $f;
} else {
 $f = $HI["hidden"];
 $f["var"] = "filetype";
 $hi[] = $f;
}

$f = $HI["hidden"];
$f["var"] = "filename";
$hi[] = $f;

if ($cmd=="new" || $f_cmd == "new") {
 if(perm($USER_ID,$T_FOLDER,$dfolder_id,13,NULL,$T_FILE,11))
 $hi[] = $HI["ok"];
} else {
 if(perm($USER_ID,$T_FOLDER,$dfolder_id,13,NULL,$T_FILE,12))
 $hi[] = $HI["ok"];
}

$hi[] = $HI["cancel"];


if ($type == "img" || $f_type == "img") {
 $default_new_name = i18n('new_image');
 $headline = i18n('new image');
 $icon = $ICO_IMG;
 $my_t_type = $T_IMAGE;
} else {
 $default_new_name = i18n('new_file');
 $headline = i18n('new file');
 $icon = $ICO_FILE;
 $my_t_type = $T_FILE;
}


if (!empty($f_name) && $default_new_name != $f_name) {
 $f_name = convertToFilename($f_name);
} else if (!empty($f_userfile_name)) {
 $f_name = convertToFilename($f_userfile_name);
} else {
 $f_name = convertToFilename($default_new_name);
}


$tmpfile = "$TMPPATH/$SESSION_TOKEN.upload"; 
if (!$f_gentics_submitted) @unlink($tmpfile);
if ($f_gentics_submitted && $f_userfile_name) {
 copy($f_userfile,$tmpfile);
 $f_filetype = $f_userfile_type;
 $f_filename = $f_userfile_name;
}


$f = new htmlform($hi);









$f->setActionUrl(url_merge_params($f->getActionUrl(),
 array("safe_type" => $type,
 "safe_cmd" => $cmd,
 "safe_id" => $id,
 "form_post" => 1)));




if ($post_max_size_exceeded
 || $_FILES['f_userfile']['error'] == UPLOAD_ERR_INI_SIZE
 || $_FILES['f_userfile']['error'] == UPLOAD_ERR_FORM_SIZE)
{
 $max_bytes = gtxreturn_bytes(min(ini_get('post_max_size'),
 ini_get('upload_max_filesize')));
 $max_size = humanfilesize($max_bytes);
 $f->elements['userfile']['error'] = i18n('File upload failed. File must be smaller than {0}.', 0, $max_size);
 $f->make_el_error('userfile');
}

if ($faction == "cancel") {

 unset($hi);
 unset($action);
 @unlink($tmpfile);
 if ($TMP_RELOAD) {
 if ($tmp_abort) unset ($reload_full);
 $REDO = 10009;
 $REDO = $TMP_REDO;
 } else $REDO = 15001;
} else {

 
 ignore_user_abort(true);

 if (!$f->err() && $faction == "ok") {
 switch ($cmd) {
 case "new":
 if ( ! perm_can_create_files($dfolder_id)) {
 halt(3, "no perms to create files in folder $dfolder_id");
 }

 if ( ! list($name, $filename, $description)
 = validate_file_props($name, $filename, $description, null, $f) )
 {
 return;
 }

 unset($FILE_ID);
 
 if ($filename) {
 $file_id = cmd_file_create($name,$dfolder_id,$description,$filename);
 
 
 $file_created_with_name = $name;
 } else {
 $f->make_el_error("userfile");
 }
 break;
 case "update":
 if ( ! perm_can_edit_file($FILE_ID)) {
 halt(3, "no perms to edit file $FILE_ID");
 }

 if (!list($name, $f_userfile_name, $description)
 = validate_file_props($name, $f_userfile_name, $description, $f_filetype, $f))
 {
 return;
 }

 cmd_file_update($FILE_ID,$dfolder_id,$name,$description,$f_userfile_name,$f_filetype,true,true);
 
 $file_id = $FILE_ID;
 break;
 }
 if ($ERROR) { 
 $f->check["cancel"] = $ERROR;
 unset($faction);
 }
 }

 if (!$f->err() && $faction == "ok") {
 
 if (file_exists($tmpfile) &&  $FILEUPLOAD_MANIPULATOR_URL) {
 $curl = new fetchCurl("POST");
 $curl->setURL($FILEUPLOAD_MANIPULATOR_URL);
 $tmpfname = tempnam($TMPPATH, 'fum');
 copy($tmpfile, $tmpfname);
 $options = array();
 foreach( $FILEUPLOAD_MANIPULATOR_OPTIONS as $key => $value ) {
 $options[$key] = $$key;
 }
 $langinfo = get_languageinfo($LANGUAGE);
 $curl->setPostData(json_encode(array(
 'id' => $tmpfname,
 'fileid' => $file_id,
 'filename' => $name,
 'mimetype' => $f_filetype,
 'url' => $CN_LOCAL_SERVER . $CN_LOCAL_PATH . '?do=15008&cmd=fetch&filename='.basename($tmpfname),
 'postponeurl' => $CN_LOCAL_SERVER . $CN_LOCAL_PATH . '?do=15008&cmd=postponedone&filename='.basename($tmpfname),
 'options' => $options,
 'lang' => $langinfo['short'],
 )));
 $rs = $curl->sendRequest();
 $answer = json_decode($rs);
 if ($answer->{'status'} == 'ACCEPTED') {
 if ($answer->{'url'}) {
 
 copy($answer->{'url'}, $tmpfile);
 } else {
 
 }
 if ($answer->{'filename'}) {
 $f_userfile_name = $name = $f_name = $filename = $answer->{'filename'};
 }
 if ($answer->{'mimetype'}) {
 $filetype = $f_filetype = $answer->{'mimetype'};
 }
 if ($answer->{'msg'}) {
 $JS .= 'alert("'.addslashes($answer->{'msg'}).'");';
 }
 @unlink($tmpfname);
 } else if ($answer->{'status'} == 'POSTPONED') {
 
 $msg = $answer->{'msg'};
 if (!$msg) {
 $msg = i18n('File Upload Manipulator was invoked and may manipulate the file at a later time.');
 }
 $JS .= 'alert("'.addslashes($msg).'");';
 } else if ($answer->{'status'} == 'DENIED') {
 $error = $answer->{'msg'};
 if (!$error) {
 $error = i18n('Error while invoking File Upload Manipulator.');
 }
 $f->elements['userfile']['error'] = $error;
 $f->make_el_error('userfile');
 warning(120, 'FUM returned an error message while uploading: ' . $rs);
 @unlink($tmpfname);
 cmd_file_del($file_id);
 } else {
 $f->elements['userfile']['error'] = i18n('Upload failed. File Upload Manipulator did not complete successfully.');
 $f->make_el_error('userfile');
 warning(120, 'FUM did not return a valid status. result: ' . $rs);
 cmd_file_del($file_id);
 }
 }
 }

 if (!$f->err() && $faction == "ok") {
 switch ($cmd) {
 case "new":
 
 
 
 if ($name != $file_created_with_name) {
 
 cmd_file_update($file_id, $dfolder_id, $name, $description,
 false, 
 false, 
 true 
 );
 }
 break;
 case "update":

 


 if ($filetype) {
 global $CN_IMAGE_MIMETYPES, $CN_IMAGE_EXTENSIONS;
 $change_type = false;
 
 if ($type == "img") {
 
 if ($CN_IMAGE_MIMETYPES && !ereg ("^(".$CN_IMAGE_MIMETYPES.")", $filetype))
 $change_type = true;
 
 if ($CN_IMAGE_EXTENSIONS && !ereg ("\.(".$CN_IMAGE_EXTENSIONS.")$", $filename))
 $change_type = true;
 
 
 if (!$CN_IMAGE_MIMETYPES && !$CN_IMAGE_EXTENSIONS && !ereg("^image",$filetype))
 $change_type = true;
 
 if ($change_type) { 
 $f->check["cancel"] = i18n('-');
 $file_id = false;
 break;
 }
 } elseif ($type == "file") {
 
 if ($CN_IMAGE_MIMETYPES && ereg ("^(".$CN_IMAGE_MIMETYPES.")", $filetype))
 $change_type = true;
 
 if ($CN_IMAGE_EXTENSIONS && ereg ("\.(".$CN_IMAGE_EXTENSIONS.")$", $filename))
 $change_type = true;
 
 
 if (!$CN_IMAGE_MIMETYPES && !$CN_IMAGE_EXTENSIONS && ereg("^image",$filetype)) {
 $change_type = true;
 }

 if ($change_type) {
 $f->check["cancel"] = i18n('fileerror_noimage');
 $file_id = false;
 break;
 }
 else { 
 if (ereg ("^image\/", $filetype)) { 
 $filetype = "application/octet-stream";
 }
 }
 }
 }
 



 
 
 $file_id = cmd_file_update($FILE_ID,$dfolder_id,$name,$description,$f_userfile_name,$f_filetype);
 break;
 }

 
 
 if ($file_id && $answer && $answer->{'status'} == 'POSTPONED') {
 file_put_contents($tmpfname.'.id', $file_id);
 }


 if ($ERROR) { 
 $f->check["cancel"] = $ERROR;
 unset($faction);
 }

 
 if ($file_id && file_exists($tmpfile)) {
 if ($type == "img" && $resize != "orig" && $resize) {
 $size = resize_image($userfile, $tmpfile, $resize, $width, $height);
 if ( $size < 0 ) {
 halt(107,"FIXME: error on resize_image");
 }
 } else {
 $f1 = fopen($tmpfile,"rb");
 $size = filesize($tmpfile);
 
 if ($size > 0) {
 $userfile = fread($f1, $size);
 }
 else {
 $userfile = "";
 }

 fclose($f1);
 }
 if ( ! perm_can_edit_file($file_id)) {
 halt(3, "no perms to edit file $FILE_ID");
 }

 list($filetype) = validate_properties_htmlform(
 array('mimeType' => $filetype),
 new NodeInputValidationRequest(),
 $f,
 array('mimeType' => 'filetype')
 );
 if ( ! is_null($filetype) ) {
 $file_id = cmd_file_data($file_id, $userfile, $size, $filetype); 
 }
 }

 
 if (!$file_id || $ERROR) {
 $f->check["name"] = $ERROR;
 
 $f_name = $name;
 } else {
 $FILE_ID = $file_id;
 
 unset($hi);
 unset($action);
 @unlink($tmpfile);
 
 
 if ($TMP_RELOAD) {
 $reload_full = $TMP_RELOAD;
 $REDO = 10009;
 $REDO = $TMP_REDO;
 $reload_full .= $FILE_ID;
 } else $REDO = 15001;
 }
 }

 
 switch ($cmd):
 case "new":
 $name = $default_new_name;
 break;
 case "update":
 if ($id) $FILE_ID = $id;
 $sql = "SELECT name, description, filetype FROM contentfile WHERE id=".sqlf_tl_num($FILE_ID);
 $rs = query($sql);
 $name= $rs["arr"][0]["name"];
 $headline = $name;
 $filetype = $rs["arr"][0]["filetype"];
 $description = $rs["arr"][0]["description"];
 $mother = $rs["arr"][0]["folder_id"];
 break;
 default:
 halt(107,"No cmd for file update or insert");
 break;
 endswitch;

}




if ($FILE_ID && ! perm_can_view_file($FILE_ID)) {
 halt(3, "no perms to view file $FILE_ID");
}


load_menu(11001, $T_FOLDER, $dfolder_id, ($cmd!="new")?$my_t_type:"");


$NODERELATED_FILE_OBJPROPS['link'] = "$STAG&do=10010&type=$my_t_type";
if( $FEATURE['objprop'] ) {
 $NODERELATED[$DO][0] = $NODERELATED_FILE_PROPERTIES;
 $NODERELATED[$DO][1] = $NODERELATED_FILE_OBJPROPS;
}
if ($type == "img") {
 $NODERELATED[$DO][] = $NODERELATED_FILE_EDIT;
}





function validate_file_props($fname, $user_fname, $description, $file_type, $html_form) {
 node_include('validation');

 if ( ! is_null($file_type) ) {
 $file_type_result = validate_properties_htmlform(
 array('mimeType' => $file_type),
 new NodeInputValidationRequest(),
 $html_form,
 array('mimeType' => 'filetype'));
 }

 
 $user_fname_result = validate_properties_htmlform(
 array('fileName' => $user_fname),
 new NodeInputValidationRequest(),
 $html_form,
 array('fileName' => 'name'));

 $result = validate_properties_htmlform(
 array('fileName' => $fname,
 'fileDescription' => $description),
 new NodeInputValidationRequest(),
 $html_form,
 array('fileName' => 'name',
 'fileDescription' => 'description'));

 return array($result['fileName'],
 $user_fname_result['fileName'],
 $result['fileDescription'],
 is_null($file_type) ? null : $file_type_result['mimeType']);
}


